/* WifiPage.c generated by valac 0.56.17, the Vala compiler
 * generated from WifiPage.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-2.1-or-later
 * SPDX-FileCopyrightText: 2015-2024 elementary, Inc. (https://elementary.io)
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "network.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <switchboard.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <granite-7.h>
#include <nma-wifi-dialog.h>
#include <gio/gio.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	NETWORK_WIFI_INTERFACE_0_PROPERTY,
	NETWORK_WIFI_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _rf_kill_device_unref0(var) ((var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block9Data Block9Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
typedef struct _NetworkWifiInterfaceConnectToNetworkData NetworkWifiInterfaceConnectToNetworkData;

struct _NetworkWifiInterfacePrivate {
	RFKillManager* rfkill;
	NMAccessPoint* active_ap;
	GtkListBox* wifi_list;
	NetworkWifiMenuItem* _active_wifi_item;
	GtkStack* placeholder;
	gboolean locked;
	gboolean software_locked;
	gboolean hardware_locked;
	guint timeout_scan;
};

struct _Block9Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMClient* client;
};

struct _Block10Data {
	int _ref_count_;
	Block9Data * _data9_;
	NMAWifiDialog* wifi_dialog;
};

struct _Block11Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMAWifiDialog* hidden_dialog;
};

struct _Block12Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMConnection* fuzzy;
	NMConnection* dialog_connection;
	gpointer _async_data_;
};

struct _NetworkWifiInterfaceConnectToNetworkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	NetworkWifiInterface* self;
	NMAWifiDialog* wifi_dialog;
	Block12Data* _data12_;
	NMDevice* dialog_device;
	NMAccessPoint* dialog_ap;
	NMDevice* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMConnection* _tmp2_;
	NetworkNetworkManager* network_manager;
	NetworkNetworkManager* _tmp3_;
	NMClient* client;
	NetworkNetworkManager* _tmp4_;
	NMClient* _tmp5_;
	NMClient* _tmp6_;
	NMClient* _tmp7_;
	GPtrArray* _tmp8_;
	gchar* path;
	NMAccessPoint* _tmp9_;
	NMAccessPoint* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	NMConnection* _tmp13_;
	NMClient* _tmp14_;
	NMConnection* _tmp15_;
	NMDeviceWifi* _tmp16_;
	const gchar* _tmp17_;
	NMActiveConnection* _tmp18_;
	NMActiveConnection* _tmp19_;
	GError* _error_;
	GError* _tmp20_;
	const gchar* _tmp21_;
	gchar* mode;
	NMSettingWireless* setting_wireless;
	NMConnection* _tmp22_;
	NMSettingWireless* _tmp23_;
	NMSettingWireless* _tmp24_;
	NMSettingWireless* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	NMSettingConnection* connection_setting;
	NMConnection* _tmp29_;
	NMSettingConnection* _tmp30_;
	NMSettingConnection* _tmp31_;
	NMSettingConnection* _tmp32_;
	NMSettingConnection* _tmp33_;
	NMConnection* _tmp34_;
	NMSettingConnection* _tmp35_;
	NMSetting* _tmp36_;
	NMClient* _tmp37_;
	NMConnection* _tmp38_;
	NMDevice* _tmp39_;
	const gchar* _tmp40_;
	NMActiveConnection* _tmp41_;
	NMActiveConnection* _tmp42_;
	GError* _vala1__error_;
	GError* _tmp43_;
	const gchar* _tmp44_;
	GError* _inner_error0_;
};

static gint NetworkWifiInterface_private_offset;
static gpointer network_wifi_interface_parent_class = NULL;

static void network_wifi_interface_real_update_name (NetworkWidgetsPage* base,
                                              gint count);
static void network_wifi_interface_access_point_added_cb (NetworkWifiInterface* self,
                                                   GObject* ap_);
static void network_wifi_interface_wifi_activate_cb (NetworkWifiInterface* self,
                                              NetworkWifiMenuItem* row);
static void _network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action (NetworkWifiMenuItem* _sender,
                                                                                  gpointer self);
static void network_wifi_interface_update_active_ap (NetworkWifiInterface* self);
static NetworkWifiMenuItem* network_wifi_interface_get_active_wifi_item (NetworkWifiInterface* self);
static void network_wifi_interface_set_active_wifi_item (NetworkWifiInterface* self,
                                                  NetworkWifiMenuItem* value);
static void network_wifi_interface_access_point_removed_cb (NetworkWifiInterface* self,
                                                     GObject* ap_);
static void network_wifi_interface_real_update (NetworkWidgetsPage* base);
static void network_wifi_interface_cancel_scan (NetworkWifiInterface* self);
static void network_wifi_interface_set_scan_placeholder (NetworkWifiInterface* self);
static void _rf_kill_device_unref0_ (gpointer var);
static inline void _g_list_free__rf_kill_device_unref0_ (GList* self);
static void ____lambda25_ (NetworkWifiInterface* self);
static void _____lambda25__gtk_button_clicked (GtkButton* _sender,
                                        gpointer self);
static void _network_widgets_page_open_advanced_settings_gtk_button_clicked (GtkButton* _sender,
                                                                      gpointer self);
static void network_wifi_interface_real_update_status (NetworkWidgetsPage* base);
static void network_wifi_interface_real_update_switch (NetworkWidgetsPage* base);
static void network_wifi_interface_real_control_switch_activated (NetworkWidgetsPage* base);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static NMConnection* network_wifi_interface_get_valid_connection (NetworkWifiInterface* self,
                                                           NMAccessPoint* ap,
                                                           GPtrArray* ap_connections);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void ___lambda20_ (Block10Data* _data10_,
                   gint response);
static void network_wifi_interface_connect_to_network (NetworkWifiInterface* self,
                                                NMAWifiDialog* wifi_dialog,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void network_wifi_interface_connect_to_network_finish (NetworkWifiInterface* self,
                                                       GAsyncResult* _res_);
static void ____lambda20__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static void ___lambda22_ (Block9Data* _data9_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda22__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static gboolean __lambda23_ (NetworkWifiInterface* self);
static gboolean ___lambda23__gsource_func (gpointer self);
static void network_wifi_interface_connect_to_hidden (NetworkWifiInterface* self);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda26_ (Block11Data* _data11_,
                  gint response);
static void ___lambda26__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void network_wifi_interface_connect_to_network_data_free (gpointer _data);
static gboolean network_wifi_interface_connect_to_network_co (NetworkWifiInterfaceConnectToNetworkData* _data_);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void __lambda21_ (Block12Data* _data12_,
                  NMRemoteConnection* possible);
static void ___lambda21__gfunc (gconstpointer data,
                         gpointer self);
static void network_wifi_interface_connect_to_network_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static gboolean ___lambda24_ (NetworkWifiInterface* self);
static gboolean ____lambda24__gsource_func (gpointer self);
static gint network_wifi_interface_sort_func (NetworkWifiInterface* self,
                                       GtkListBoxRow* r1,
                                       GtkListBoxRow* r2);
static GObject * network_wifi_interface_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static gint _network_wifi_interface_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                               GtkListBoxRow* row2,
                                                               gpointer self);
static void _network_widgets_page_edit_connections_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _network_wifi_interface_connect_to_hidden_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_added (RFKillManager* _sender,
                                                                RFKillDevice* device,
                                                                gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_changed (RFKillManager* _sender,
                                                                  RFKillDevice* device,
                                                                  gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_deleted (RFKillManager* _sender,
                                                                  RFKillDevice* device,
                                                                  gpointer self);
static void _network_widgets_page_update_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void _network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added (NMDeviceWifi* _sender,
                                                                                      GObject* ap,
                                                                                      gpointer self);
static void _network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed (NMDeviceWifi* _sender,
                                                                                          GObject* ap,
                                                                                          gpointer self);
static void _network_widgets_page_update_nm_device_state_changed (NMDevice* _sender,
                                                           guint new_state,
                                                           guint old_state,
                                                           guint reason,
                                                           gpointer self);
static void _network_wifi_interface_access_point_added_cb_gfunc (gconstpointer data,
                                                          gpointer self);
static void network_wifi_interface_finalize (GObject * obj);
static GType network_wifi_interface_get_type_once (void);
static void _vala_network_wifi_interface_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_interface_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_interface_get_instance_private (NetworkWifiInterface* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiInterface_private_offset);
}

NetworkWifiInterface*
network_wifi_interface_construct (GType object_type,
                                  NMDevice* device)
{
	NetworkWifiInterface * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	self = (NetworkWifiInterface*) g_object_new (object_type, "activatable", TRUE, "device", device, NULL);
	return self;
}

NetworkWifiInterface*
network_wifi_interface_new (NMDevice* device)
{
	return network_wifi_interface_construct (NETWORK_TYPE_WIFI_INTERFACE, device);
}

static void
network_wifi_interface_real_update_name (NetworkWidgetsPage* base,
                                         gint count)
{
	NetworkWifiInterface * self;
	self = (NetworkWifiInterface*) base;
	if (count <= 1) {
		switchboard_settings_page_set_title ((SwitchboardSettingsPage*) self, _ ("Wireless"));
	} else {
		NMDevice* _tmp0_;
		NMDevice* _tmp1_;
		const gchar* _tmp2_;
		_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = nm_device_get_description (_tmp1_);
		switchboard_settings_page_set_title ((SwitchboardSettingsPage*) self, _tmp2_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action (NetworkWifiMenuItem* _sender,
                                                                             gpointer self)
{
	network_wifi_interface_wifi_activate_cb ((NetworkWifiInterface*) self, _sender);
}

static void
network_wifi_interface_access_point_added_cb (NetworkWifiInterface* self,
                                              GObject* ap_)
{
	NMAccessPoint* ap = NULL;
	NMAccessPoint* _tmp0_;
	gboolean found = FALSE;
	NMAccessPoint* _tmp1_;
	GBytes* _tmp2_;
	GBytes* _tmp3_;
	gboolean _tmp20_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap_ != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ap_, nm_access_point_get_type (), NMAccessPoint));
	ap = _tmp0_;
	found = FALSE;
	_tmp1_ = ap;
	_tmp2_ = nm_access_point_get_ssid (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		GtkWidget* child = NULL;
		GtkListBox* _tmp4_;
		GtkWidget* _tmp5_;
		_tmp4_ = self->priv->wifi_list;
		_tmp5_ = gtk_widget_get_first_child ((GtkWidget*) _tmp4_);
		child = _tmp5_;
		while (TRUE) {
			GtkWidget* _tmp6_;
			GtkWidget* _tmp7_;
			GtkWidget* _tmp18_;
			GtkWidget* _tmp19_;
			_tmp6_ = child;
			if (!(_tmp6_ != NULL)) {
				break;
			}
			_tmp7_ = child;
			if (NETWORK_IS_WIFI_MENU_ITEM (_tmp7_)) {
				NetworkWifiMenuItem* menu_item = NULL;
				GtkWidget* _tmp8_;
				NetworkWifiMenuItem* _tmp9_;
				NMAccessPoint* _tmp10_;
				GBytes* _tmp11_;
				GBytes* _tmp12_;
				NetworkWifiMenuItem* _tmp13_;
				GBytes* _tmp14_;
				GBytes* _tmp15_;
				_tmp8_ = child;
				_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
				menu_item = _tmp9_;
				_tmp10_ = ap;
				_tmp11_ = nm_access_point_get_ssid (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = menu_item;
				_tmp14_ = network_wifi_menu_item_get_ssid (_tmp13_);
				_tmp15_ = _tmp14_;
				if (g_bytes_compare (_tmp12_, _tmp15_) == 0) {
					NetworkWifiMenuItem* _tmp16_;
					NMAccessPoint* _tmp17_;
					found = TRUE;
					_tmp16_ = menu_item;
					_tmp17_ = ap;
					network_wifi_menu_item_add_ap (_tmp16_, _tmp17_);
					_g_object_unref0 (menu_item);
					break;
				}
				_g_object_unref0 (menu_item);
			}
			_tmp18_ = child;
			_tmp19_ = gtk_widget_get_next_sibling (_tmp18_);
			child = _tmp19_;
		}
	}
	if (!found) {
		NMAccessPoint* _tmp21_;
		GBytes* _tmp22_;
		GBytes* _tmp23_;
		_tmp21_ = ap;
		_tmp22_ = nm_access_point_get_ssid (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp20_ = _tmp23_ != NULL;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		NetworkWifiMenuItem* item = NULL;
		NMAccessPoint* _tmp24_;
		NetworkWifiMenuItem* _tmp25_ = NULL;
		NetworkWifiMenuItem* _tmp26_;
		GtkListBox* _tmp27_;
		NetworkWifiMenuItem* _tmp28_;
		_tmp24_ = ap;
		_tmp25_ = network_wifi_menu_item_new (_tmp24_);
		gtk_widget_set_visible ((GtkWidget*) _tmp25_, TRUE);
		g_object_ref_sink (_tmp25_);
		item = _tmp25_;
		_tmp26_ = item;
		g_signal_connect_object (_tmp26_, "user-action", (GCallback) _network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action, self, 0);
		_tmp27_ = self->priv->wifi_list;
		_tmp28_ = item;
		gtk_list_box_append (_tmp27_, (GtkWidget*) _tmp28_);
		network_widgets_page_update ((NetworkWidgetsPage*) self);
		_g_object_unref0 (item);
	}
	_g_object_unref0 (ap);
}

static void
network_wifi_interface_update_active_ap (NetworkWifiInterface* self)
{
	NMDeviceWifi* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	NetworkWifiMenuItem* _tmp3_;
	NMAccessPoint* _tmp8_;
	g_return_if_fail (self != NULL);
	g_debug ("WifiPage.vala:209: Update active AP");
	_tmp0_ = self->wifi_device;
	_tmp1_ = nm_device_wifi_get_active_access_point (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->active_ap);
	self->priv->active_ap = _tmp2_;
	_tmp3_ = self->priv->_active_wifi_item;
	if (_tmp3_ != NULL) {
		NetworkWifiMenuItem* _tmp4_;
		NMDeviceState _tmp5_;
		NMDeviceState _tmp6_;
		_tmp4_ = self->priv->_active_wifi_item;
		_tmp5_ = network_wifi_menu_item_get_state (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ == NM_DEVICE_STATE_PREPARE) {
			NetworkWifiMenuItem* _tmp7_;
			_tmp7_ = self->priv->_active_wifi_item;
			network_wifi_menu_item_set_state (_tmp7_, NM_DEVICE_STATE_DISCONNECTED);
		}
		network_wifi_interface_set_active_wifi_item (self, NULL);
	}
	_tmp8_ = self->priv->active_ap;
	if (_tmp8_ == NULL) {
		g_debug ("WifiPage.vala:221: No active AP");
	} else {
		NMAccessPoint* _tmp9_;
		GBytes* _tmp10_;
		gsize _tmp11_ = 0;
		guint8* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean found = FALSE;
		GtkWidget* child = NULL;
		GtkListBox* _tmp15_;
		GtkWidget* _tmp16_;
		_tmp9_ = self->priv->active_ap;
		_tmp10_ = nm_access_point_get_ssid (_tmp9_);
		_tmp12_ = g_bytes_get_data (_tmp10_, &_tmp11_);
		_tmp13_ = nm_utils_ssid_to_utf8 (_tmp12_, (gsize) _tmp11_);
		_tmp14_ = _tmp13_;
		g_debug ("WifiPage.vala:223: Active ap: %s", _tmp14_);
		_g_free0 (_tmp14_);
		found = FALSE;
		_tmp15_ = self->priv->wifi_list;
		_tmp16_ = gtk_widget_get_first_child ((GtkWidget*) _tmp15_);
		child = _tmp16_;
		while (TRUE) {
			gboolean _tmp17_ = FALSE;
			GtkWidget* _tmp18_;
			GtkWidget* _tmp19_;
			GtkWidget* _tmp33_;
			GtkWidget* _tmp34_;
			_tmp18_ = child;
			if (_tmp18_ != NULL) {
				_tmp17_ = !found;
			} else {
				_tmp17_ = FALSE;
			}
			if (!_tmp17_) {
				break;
			}
			_tmp19_ = child;
			if (NETWORK_IS_WIFI_MENU_ITEM (_tmp19_)) {
				NetworkWifiMenuItem* menu_item = NULL;
				GtkWidget* _tmp20_;
				NetworkWifiMenuItem* _tmp21_;
				NMAccessPoint* _tmp22_;
				GBytes* _tmp23_;
				GBytes* _tmp24_;
				NetworkWifiMenuItem* _tmp25_;
				GBytes* _tmp26_;
				GBytes* _tmp27_;
				_tmp20_ = child;
				_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
				menu_item = _tmp21_;
				_tmp22_ = self->priv->active_ap;
				_tmp23_ = nm_access_point_get_ssid (_tmp22_);
				_tmp24_ = _tmp23_;
				_tmp25_ = menu_item;
				_tmp26_ = network_wifi_menu_item_get_ssid (_tmp25_);
				_tmp27_ = _tmp26_;
				if (g_bytes_compare (_tmp24_, _tmp27_) == 0) {
					NetworkWifiMenuItem* _tmp28_;
					NetworkWifiMenuItem* _tmp29_;
					NetworkWifiMenuItem* _tmp30_;
					NMDeviceState _tmp31_;
					NMDeviceState _tmp32_;
					found = TRUE;
					_tmp28_ = menu_item;
					network_wifi_menu_item_set_active (_tmp28_, TRUE);
					_tmp29_ = menu_item;
					network_wifi_interface_set_active_wifi_item (self, _tmp29_);
					_tmp30_ = self->priv->_active_wifi_item;
					_tmp31_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
					_tmp32_ = _tmp31_;
					network_wifi_menu_item_set_state (_tmp30_, _tmp32_);
				}
				_g_object_unref0 (menu_item);
			}
			_tmp33_ = child;
			_tmp34_ = gtk_widget_get_next_sibling (_tmp33_);
			child = _tmp34_;
		}
		if (!found) {
			g_debug ("WifiPage.vala:244: Active AP not added");
		}
	}
}

static void
network_wifi_interface_access_point_removed_cb (NetworkWifiInterface* self,
                                                GObject* ap_)
{
	NMAccessPoint* ap = NULL;
	NMAccessPoint* _tmp0_;
	NetworkWifiMenuItem* found_item = NULL;
	GtkWidget* child = NULL;
	GtkListBox* _tmp1_;
	GtkWidget* _tmp2_;
	NetworkWifiMenuItem* _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap_ != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ap_, nm_access_point_get_type (), NMAccessPoint));
	ap = _tmp0_;
	found_item = NULL;
	_tmp1_ = self->priv->wifi_list;
	_tmp2_ = gtk_widget_get_first_child ((GtkWidget*) _tmp1_);
	child = _tmp2_;
	while (TRUE) {
		gboolean _tmp3_ = FALSE;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp17_;
		GtkWidget* _tmp18_;
		_tmp4_ = child;
		if (_tmp4_ != NULL) {
			NetworkWifiMenuItem* _tmp5_;
			_tmp5_ = found_item;
			_tmp3_ = _tmp5_ == NULL;
		} else {
			_tmp3_ = FALSE;
		}
		if (!_tmp3_) {
			break;
		}
		_tmp6_ = child;
		if (NETWORK_IS_WIFI_MENU_ITEM (_tmp6_)) {
			NetworkWifiMenuItem* menu_item = NULL;
			GtkWidget* _tmp7_;
			NetworkWifiMenuItem* _tmp8_;
			NMAccessPoint* _tmp9_;
			GBytes* _tmp10_;
			GBytes* _tmp11_;
			NetworkWifiMenuItem* _tmp12_;
			GBytes* _tmp13_;
			GBytes* _tmp14_;
			_tmp7_ = child;
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
			menu_item = _tmp8_;
			_tmp9_ = ap;
			_tmp10_ = nm_access_point_get_ssid (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = menu_item;
			_tmp13_ = network_wifi_menu_item_get_ssid (_tmp12_);
			_tmp14_ = _tmp13_;
			if (g_bytes_compare (_tmp11_, _tmp14_) == 0) {
				NetworkWifiMenuItem* _tmp15_;
				NetworkWifiMenuItem* _tmp16_;
				_tmp15_ = menu_item;
				_tmp16_ = _g_object_ref0 (_tmp15_);
				_g_object_unref0 (found_item);
				found_item = _tmp16_;
			}
			_g_object_unref0 (menu_item);
		}
		_tmp17_ = child;
		_tmp18_ = gtk_widget_get_next_sibling (_tmp17_);
		child = _tmp18_;
	}
	_tmp19_ = found_item;
	if (_tmp19_ == NULL) {
		g_critical ("WifiPage.vala:267: Couldn't remove an access point which has not been " \
"added.");
	} else {
		NetworkWifiMenuItem* _tmp20_;
		NMAccessPoint* _tmp21_;
		_tmp20_ = found_item;
		_tmp21_ = ap;
		if (!network_wifi_menu_item_remove_ap (_tmp20_, _tmp21_)) {
			NetworkWifiMenuItem* _tmp22_;
			_tmp22_ = found_item;
			g_signal_emit_by_name ((GtkWidget*) _tmp22_, "destroy");
		}
	}
	network_widgets_page_update ((NetworkWidgetsPage*) self);
	_g_object_unref0 (found_item);
	_g_object_unref0 (ap);
}

static gpointer
_rf_kill_device_ref0 (gpointer self)
{
	return self ? rf_kill_device_ref (self) : NULL;
}

static void
_rf_kill_device_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL));
}

static inline void
_g_list_free__rf_kill_device_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _rf_kill_device_unref0_);
}

static void
____lambda25_ (NetworkWifiInterface* self)
{
	GError* _inner_error0_ = NULL;
	{
		NMDevice* _tmp0_;
		NMDevice* _tmp1_;
		_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
		_tmp1_ = _tmp0_;
		nm_device_disconnect (_tmp1_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_warning ("WifiPage.vala:389: %s", _tmp3_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
_____lambda25__gtk_button_clicked (GtkButton* _sender,
                                   gpointer self)
{
	____lambda25_ ((NetworkWifiInterface*) self);
}

static void
_network_widgets_page_open_advanced_settings_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self)
{
	network_widgets_page_open_advanced_settings ((NetworkWidgetsPage*) self);
}

static void
network_wifi_interface_real_update (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	gboolean sensitive = FALSE;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp4_;
	GtkMenuButton* _tmp6_;
	GtkButton* _tmp8_;
	NetworkWifiMenuItem* old_active = NULL;
	NetworkWifiMenuItem* _tmp12_;
	NetworkWifiMenuItem* _tmp13_;
	NMDeviceWifi* _tmp14_;
	NMDeviceWifi* _tmp15_;
	NMDeviceState _tmp16_;
	NMDeviceState _tmp17_;
	NMDeviceWifi* _tmp23_;
	NMDeviceState _tmp24_;
	NMDeviceState _tmp25_;
	NMDeviceState _tmp26_;
	NMDeviceState _tmp27_;
	GEnumValue* _tmp28_;
	RFKillManager* _tmp29_;
	GList* _tmp30_;
	gboolean _tmp41_ = FALSE;
	gboolean is_hotspot = FALSE;
	NMDeviceWifi* _tmp42_;
	NMAccessPoint* active_access_point = NULL;
	NMDeviceWifi* _tmp43_;
	NMAccessPoint* _tmp44_;
	NMAccessPoint* _tmp45_;
	gboolean _tmp46_ = FALSE;
	NMAccessPoint* _tmp47_;
	GtkRevealer* _tmp48_;
	gboolean _tmp53_ = FALSE;
	NMAccessPoint* _tmp54_;
	self = (NetworkWifiInterface*) base;
	_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
	_tmp1_ = _tmp0_;
	sensitive = nm_device_get_state (_tmp1_) == NM_DEVICE_STATE_ACTIVATED;
	_tmp2_ = self->disconnect_btn;
	if (_tmp2_ != NULL) {
		GtkButton* _tmp3_;
		_tmp3_ = self->disconnect_btn;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, sensitive);
	}
	_tmp4_ = self->settings_btn;
	if (_tmp4_ != NULL) {
		GtkButton* _tmp5_;
		_tmp5_ = self->settings_btn;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, sensitive);
	}
	_tmp6_ = self->info_btn;
	if (_tmp6_ != NULL) {
		GtkMenuButton* _tmp7_;
		_tmp7_ = self->info_btn;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, sensitive);
	}
	_tmp8_ = self->hidden_btn;
	if (_tmp8_ != NULL) {
		GtkButton* _tmp9_;
		NMDeviceState _tmp10_;
		NMDeviceState _tmp11_;
		_tmp9_ = self->hidden_btn;
		_tmp10_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
		_tmp11_ = _tmp10_;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, _tmp11_ != NM_DEVICE_STATE_UNAVAILABLE);
	}
	_tmp12_ = self->priv->_active_wifi_item;
	_tmp13_ = _g_object_ref0 (_tmp12_);
	old_active = _tmp13_;
	_tmp14_ = self->wifi_device;
	if (network_utils_get_device_is_hotspot (_tmp14_)) {
		network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_DISCONNECTED);
		_g_object_unref0 (old_active);
		return;
	}
	_tmp15_ = self->wifi_device;
	_tmp16_ = nm_device_get_state ((NMDevice*) _tmp15_);
	_tmp17_ = _tmp16_;
	switch (_tmp17_) {
		case NM_DEVICE_STATE_UNKNOWN:
		case NM_DEVICE_STATE_UNMANAGED:
		case NM_DEVICE_STATE_FAILED:
		{
			NetworkWifiMenuItem* _tmp18_;
			_tmp18_ = self->priv->_active_wifi_item;
			if (_tmp18_ != NULL) {
				NetworkWifiMenuItem* _tmp19_;
				NMDeviceState _tmp20_;
				NMDeviceState _tmp21_;
				_tmp19_ = self->priv->_active_wifi_item;
				_tmp20_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
				_tmp21_ = _tmp20_;
				network_wifi_menu_item_set_state (_tmp19_, _tmp21_);
			}
			network_wifi_interface_cancel_scan (self);
			break;
		}
		case NM_DEVICE_STATE_DEACTIVATING:
		case NM_DEVICE_STATE_UNAVAILABLE:
		{
			GtkStack* _tmp22_;
			network_wifi_interface_cancel_scan (self);
			_tmp22_ = self->priv->placeholder;
			gtk_stack_set_visible_child_name (_tmp22_, "wireless-off");
			break;
		}
		default:
		{
			network_wifi_interface_set_scan_placeholder (self);
			break;
		}
	}
	_tmp23_ = self->wifi_device;
	_tmp24_ = nm_device_get_state ((NMDevice*) _tmp23_);
	_tmp25_ = _tmp24_;
	network_widgets_page_set_state ((NetworkWidgetsPage*) self, _tmp25_);
	_tmp26_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_enum_get_value (g_type_class_ref (nm_device_state_get_type ()), _tmp27_);
	g_debug ("WifiPage.vala:324: New network state: %s", (_tmp28_ != NULL) ? _tmp28_->value_name : NULL);
	self->priv->software_locked = FALSE;
	self->priv->hardware_locked = FALSE;
	_tmp29_ = self->priv->rfkill;
	_tmp30_ = rf_kill_manager_get_devices (_tmp29_);
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = _tmp30_;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			RFKillDevice* _tmp31_;
			RFKillDevice* device = NULL;
			_tmp31_ = _rf_kill_device_ref0 ((RFKillDevice*) device_it->data);
			device = _tmp31_;
			{
				RFKillDevice* _tmp32_;
				RFKillDeviceType _tmp33_;
				RFKillDeviceType _tmp34_;
				RFKillDevice* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
				RFKillDevice* _tmp38_;
				gboolean _tmp39_;
				gboolean _tmp40_;
				_tmp32_ = device;
				_tmp33_ = rf_kill_device_get_device_type (_tmp32_);
				_tmp34_ = _tmp33_;
				if (_tmp34_ != RF_KILL_DEVICE_TYPE_WLAN) {
					_rf_kill_device_unref0 (device);
					continue;
				}
				_tmp35_ = device;
				_tmp36_ = rf_kill_device_get_software_lock (_tmp35_);
				_tmp37_ = _tmp36_;
				if (_tmp37_) {
					self->priv->software_locked = TRUE;
				}
				_tmp38_ = device;
				_tmp39_ = rf_kill_device_get_hardware_lock (_tmp38_);
				_tmp40_ = _tmp39_;
				if (_tmp40_) {
					self->priv->hardware_locked = TRUE;
				}
				_rf_kill_device_unref0 (device);
			}
		}
		(device_collection == NULL) ? NULL : (device_collection = (_g_list_free__rf_kill_device_unref0_ (device_collection), NULL));
	}
	if (self->priv->hardware_locked) {
		_tmp41_ = TRUE;
	} else {
		_tmp41_ = self->priv->software_locked;
	}
	self->priv->locked = _tmp41_;
	network_wifi_interface_update_active_ap (self);
	NETWORK_WIDGETS_PAGE_CLASS (network_wifi_interface_parent_class)->update (G_TYPE_CHECK_INSTANCE_CAST (self, NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPage));
	_tmp42_ = self->wifi_device;
	is_hotspot = network_utils_get_device_is_hotspot (_tmp42_);
	_tmp43_ = self->wifi_device;
	_tmp44_ = nm_device_wifi_get_active_access_point (_tmp43_);
	_tmp45_ = _tmp44_;
	active_access_point = _tmp45_;
	_tmp47_ = active_access_point;
	if (_tmp47_ != NULL) {
		_tmp46_ = !is_hotspot;
	} else {
		_tmp46_ = FALSE;
	}
	_tmp48_ = self->top_revealer;
	gtk_revealer_set_reveal_child (_tmp48_, _tmp46_);
	if (is_hotspot) {
		GtkStack* _tmp49_;
		GtkBox* _tmp50_;
		_tmp49_ = self->list_stack;
		_tmp50_ = self->hotspot_mode_alert;
		gtk_stack_set_visible_child (_tmp49_, (GtkWidget*) _tmp50_);
	} else {
		GtkStack* _tmp51_;
		GtkScrolledWindow* _tmp52_;
		_tmp51_ = self->list_stack;
		_tmp52_ = self->scrolled;
		gtk_stack_set_visible_child (_tmp51_, (GtkWidget*) _tmp52_);
	}
	_tmp54_ = active_access_point;
	if (_tmp54_ == NULL) {
		NetworkWifiMenuItem* _tmp55_;
		_tmp55_ = old_active;
		_tmp53_ = _tmp55_ != NULL;
	} else {
		_tmp53_ = FALSE;
	}
	if (_tmp53_) {
		NetworkWifiMenuItem* _tmp56_;
		gboolean _tmp57_ = FALSE;
		GtkFrame* _tmp58_;
		GtkButton* _tmp63_;
		GtkButton* _tmp64_;
		_tmp56_ = old_active;
		gtk_widget_set_visible ((GtkWidget*) _tmp56_, TRUE);
		_tmp58_ = self->connected_frame;
		if (_tmp58_ != NULL) {
			GtkFrame* _tmp59_;
			GtkWidget* _tmp60_;
			_tmp59_ = self->connected_frame;
			_tmp60_ = gtk_frame_get_child (_tmp59_);
			_tmp57_ = _tmp60_ != NULL;
		} else {
			_tmp57_ = FALSE;
		}
		if (_tmp57_) {
			GtkFrame* _tmp61_;
			GtkWidget* _tmp62_;
			_tmp61_ = self->connected_frame;
			_tmp62_ = gtk_frame_get_child (_tmp61_);
			g_signal_emit_by_name (_tmp62_, "destroy");
		}
		_g_object_unref0 (self->settings_btn);
		self->settings_btn = NULL;
		_tmp63_ = self->settings_btn;
		_tmp64_ = _g_object_ref0 (_tmp63_);
		_g_object_unref0 (self->disconnect_btn);
		self->disconnect_btn = _tmp64_;
	} else {
		gboolean _tmp65_ = FALSE;
		NMAccessPoint* _tmp66_;
		_tmp66_ = active_access_point;
		if (_tmp66_ != NULL) {
			NetworkWifiMenuItem* _tmp67_;
			NetworkWifiMenuItem* _tmp68_;
			_tmp67_ = self->priv->_active_wifi_item;
			_tmp68_ = old_active;
			_tmp65_ = _tmp67_ != _tmp68_;
		} else {
			_tmp65_ = FALSE;
		}
		if (_tmp65_) {
			NetworkWifiMenuItem* _tmp69_;
			NetworkWifiMenuItem* _tmp77_;
			NetworkWifiMenuItem* top_item = NULL;
			NMAccessPoint* _tmp78_;
			NetworkWifiMenuItem* _tmp79_ = NULL;
			NMDevice* _tmp80_;
			NMDevice* _tmp81_;
			GtkButton* _tmp82_ = NULL;
			GtkButton* _tmp83_;
			GtkButton* _tmp84_;
			NMDevice* _tmp85_;
			NMDevice* _tmp86_;
			GtkButton* _tmp87_ = NULL;
			GtkButton* _tmp88_;
			gchar* _tmp89_;
			GtkPopover* _tmp90_;
			GtkPopover* _tmp91_;
			gchar* _tmp92_;
			GtkMenuButton* _tmp93_ = NULL;
			GtkMenuButton* _tmp94_;
			GtkBox* button_box = NULL;
			GtkBox* _tmp95_ = NULL;
			GtkBox* _tmp96_;
			GtkButton* _tmp97_;
			GtkBox* _tmp98_;
			GtkButton* _tmp99_;
			GtkBox* connected_box = NULL;
			GtkBox* _tmp100_;
			GtkBox* _tmp101_;
			NetworkWifiMenuItem* _tmp102_;
			GtkBox* _tmp103_;
			GtkMenuButton* _tmp104_;
			GtkBox* _tmp105_;
			GtkBox* _tmp106_;
			GtkListBox* connected_listbox = NULL;
			GtkListBox* _tmp107_ = NULL;
			GtkListBox* _tmp108_;
			GtkListBox* _tmp109_;
			GtkBox* _tmp110_;
			GtkListBox* _tmp111_;
			GtkWidget* _tmp112_;
			GtkFrame* _tmp113_;
			GtkListBox* _tmp114_;
			_tmp69_ = old_active;
			if (_tmp69_ != NULL) {
				NetworkWifiMenuItem* _tmp70_;
				gboolean _tmp71_ = FALSE;
				GtkFrame* _tmp72_;
				_tmp70_ = old_active;
				gtk_widget_set_visible ((GtkWidget*) _tmp70_, TRUE);
				_tmp72_ = self->connected_frame;
				if (_tmp72_ != NULL) {
					GtkFrame* _tmp73_;
					GtkWidget* _tmp74_;
					_tmp73_ = self->connected_frame;
					_tmp74_ = gtk_frame_get_child (_tmp73_);
					_tmp71_ = _tmp74_ != NULL;
				} else {
					_tmp71_ = FALSE;
				}
				if (_tmp71_) {
					GtkFrame* _tmp75_;
					GtkWidget* _tmp76_;
					_tmp75_ = self->connected_frame;
					_tmp76_ = gtk_frame_get_child (_tmp75_);
					g_signal_emit_by_name (_tmp76_, "destroy");
				}
			}
			_tmp77_ = self->priv->_active_wifi_item;
			gtk_widget_set_visible ((GtkWidget*) _tmp77_, FALSE);
			_tmp78_ = active_access_point;
			_tmp79_ = network_wifi_menu_item_new (_tmp78_);
			gtk_widget_set_hexpand ((GtkWidget*) _tmp79_, TRUE);
			network_wifi_menu_item_set_state (_tmp79_, NM_DEVICE_STATE_ACTIVATED);
			g_object_ref_sink (_tmp79_);
			top_item = _tmp79_;
			_tmp80_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
			_tmp81_ = _tmp80_;
			_tmp82_ = (GtkButton*) gtk_button_new_with_label (_ ("Disconnect"));
			gtk_widget_set_sensitive ((GtkWidget*) _tmp82_, nm_device_get_state (_tmp81_) == NM_DEVICE_STATE_ACTIVATED);
			g_object_ref_sink (_tmp82_);
			_g_object_unref0 (self->disconnect_btn);
			self->disconnect_btn = _tmp82_;
			_tmp83_ = self->disconnect_btn;
			gtk_widget_add_css_class ((GtkWidget*) _tmp83_, GRANITE_STYLE_CLASS_DESTRUCTIVE_ACTION);
			_tmp84_ = self->disconnect_btn;
			g_signal_connect_object (_tmp84_, "clicked", (GCallback) _____lambda25__gtk_button_clicked, self, 0);
			_tmp85_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
			_tmp86_ = _tmp85_;
			_tmp87_ = (GtkButton*) gtk_button_new_with_label (_ ("Settings…"));
			gtk_widget_set_sensitive ((GtkWidget*) _tmp87_, nm_device_get_state (_tmp86_) == NM_DEVICE_STATE_ACTIVATED);
			g_object_ref_sink (_tmp87_);
			_g_object_unref0 (self->settings_btn);
			self->settings_btn = _tmp87_;
			_tmp88_ = self->settings_btn;
			g_signal_connect_object (_tmp88_, "clicked", (GCallback) _network_widgets_page_open_advanced_settings_gtk_button_clicked, (NetworkWidgetsPage*) self, 0);
			_tmp89_ = g_strdup ("view-more-symbolic");
			_tmp90_ = self->popover;
			_tmp91_ = _g_object_ref0 (_tmp90_);
			_tmp92_ = g_strdup (_ ("Connection info"));
			_tmp93_ = (GtkMenuButton*) gtk_menu_button_new ();
			gtk_menu_button_set_icon_name (_tmp93_, _tmp89_);
			_g_free0 (_tmp89_);
			gtk_menu_button_set_popover (_tmp93_, _tmp91_);
			_g_object_unref0 (_tmp91_);
			gtk_widget_set_valign ((GtkWidget*) _tmp93_, GTK_ALIGN_CENTER);
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp93_, _tmp92_);
			_g_free0 (_tmp92_);
			g_object_ref_sink (_tmp93_);
			_g_object_unref0 (self->info_btn);
			self->info_btn = _tmp93_;
			_tmp94_ = self->info_btn;
			gtk_widget_add_css_class ((GtkWidget*) _tmp94_, GRANITE_STYLE_CLASS_FLAT);
			_tmp95_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
			gtk_box_set_homogeneous (_tmp95_, TRUE);
			gtk_widget_set_valign ((GtkWidget*) _tmp95_, GTK_ALIGN_CENTER);
			g_object_ref_sink (_tmp95_);
			button_box = _tmp95_;
			_tmp96_ = button_box;
			_tmp97_ = self->settings_btn;
			gtk_box_append (_tmp96_, (GtkWidget*) _tmp97_);
			_tmp98_ = button_box;
			_tmp99_ = self->disconnect_btn;
			gtk_box_append (_tmp98_, (GtkWidget*) _tmp99_);
			_tmp100_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
			g_object_ref_sink (_tmp100_);
			connected_box = _tmp100_;
			_tmp101_ = connected_box;
			_tmp102_ = top_item;
			gtk_box_append (_tmp101_, (GtkWidget*) _tmp102_);
			_tmp103_ = connected_box;
			_tmp104_ = self->info_btn;
			gtk_box_append (_tmp103_, (GtkWidget*) _tmp104_);
			_tmp105_ = connected_box;
			_tmp106_ = button_box;
			gtk_box_append (_tmp105_, (GtkWidget*) _tmp106_);
			_tmp107_ = (GtkListBox*) gtk_list_box_new ();
			gtk_list_box_set_selection_mode (_tmp107_, GTK_SELECTION_NONE);
			g_object_ref_sink (_tmp107_);
			connected_listbox = _tmp107_;
			_tmp108_ = connected_listbox;
			gtk_widget_add_css_class ((GtkWidget*) _tmp108_, GRANITE_STYLE_CLASS_RICH_LIST);
			_tmp109_ = connected_listbox;
			_tmp110_ = connected_box;
			gtk_list_box_append (_tmp109_, (GtkWidget*) _tmp110_);
			_tmp111_ = connected_listbox;
			_tmp112_ = gtk_widget_get_first_child ((GtkWidget*) _tmp111_);
			gtk_widget_set_focusable (_tmp112_, FALSE);
			_tmp113_ = self->connected_frame;
			_tmp114_ = connected_listbox;
			gtk_frame_set_child (_tmp113_, (GtkWidget*) _tmp114_);
			_g_object_unref0 (connected_listbox);
			_g_object_unref0 (connected_box);
			_g_object_unref0 (button_box);
			_g_object_unref0 (top_item);
		}
	}
	_g_object_unref0 (old_active);
}

static void
network_wifi_interface_real_update_status (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
	NMDeviceState _tmp2_;
	NMDeviceState _tmp3_;
	NMDevice* _tmp4_;
	NMDevice* _tmp5_;
	NMDeviceState _tmp6_;
	NMDeviceState _tmp7_;
	self = (NetworkWifiInterface*) base;
	_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = nm_device_get_state (_tmp1_);
	_tmp3_ = _tmp2_;
	switch (_tmp3_) {
		case NM_DEVICE_STATE_ACTIVATED:
		{
			switchboard_settings_page_set_status_type ((SwitchboardSettingsPage*) self, SWITCHBOARD_SETTINGS_PAGE_STATUS_TYPE_SUCCESS);
			break;
		}
		case NM_DEVICE_STATE_DISCONNECTED:
		{
			switchboard_settings_page_set_status_type ((SwitchboardSettingsPage*) self, SWITCHBOARD_SETTINGS_PAGE_STATUS_TYPE_OFFLINE);
			break;
		}
		case NM_DEVICE_STATE_FAILED:
		{
			switchboard_settings_page_set_status_type ((SwitchboardSettingsPage*) self, SWITCHBOARD_SETTINGS_PAGE_STATUS_TYPE_ERROR);
			break;
		}
		default:
		{
			switchboard_settings_page_set_status_type ((SwitchboardSettingsPage*) self, SWITCHBOARD_SETTINGS_PAGE_STATUS_TYPE_WARNING);
			break;
		}
	}
	_tmp4_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = nm_device_get_state (_tmp5_);
	_tmp7_ = _tmp6_;
	switch (_tmp7_) {
		case NM_DEVICE_STATE_UNAVAILABLE:
		{
			switchboard_settings_page_set_status ((SwitchboardSettingsPage*) self, _ ("Disabled"));
			break;
		}
		case NM_DEVICE_STATE_ACTIVATED:
		{
			NMDevice* _tmp8_;
			NMDevice* _tmp9_;
			NMAccessPoint* _tmp10_;
			NMAccessPoint* _tmp11_;
			GBytes* _tmp12_;
			gsize _tmp13_ = 0;
			guint8* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			_tmp8_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
			_tmp9_ = _tmp8_;
			_tmp10_ = nm_device_wifi_get_active_access_point (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, nm_device_wifi_get_type (), NMDeviceWifi));
			_tmp11_ = _tmp10_;
			_tmp12_ = nm_access_point_get_ssid (_tmp11_);
			_tmp14_ = g_bytes_get_data (_tmp12_, &_tmp13_);
			_tmp15_ = nm_utils_ssid_to_utf8 (_tmp14_, (gsize) _tmp13_);
			_tmp16_ = _tmp15_;
			switchboard_settings_page_set_status ((SwitchboardSettingsPage*) self, _tmp16_);
			_g_free0 (_tmp16_);
			break;
		}
		default:
		{
			NMDevice* _tmp17_;
			NMDevice* _tmp18_;
			NMDeviceState _tmp19_;
			NMDeviceState _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp17_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
			_tmp18_ = _tmp17_;
			_tmp19_ = nm_device_get_state (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = network_utils_state_to_string (_tmp20_);
			_tmp22_ = _tmp21_;
			switchboard_settings_page_set_status ((SwitchboardSettingsPage*) self, _tmp22_);
			_g_free0 (_tmp22_);
			break;
		}
	}
}

static void
network_wifi_interface_real_update_switch (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	self = (NetworkWifiInterface*) base;
	_tmp0_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
	_tmp1_ = _tmp0_;
	gtk_switch_set_active (_tmp1_, !self->priv->software_locked);
}

static void
network_wifi_interface_real_control_switch_activated (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	gboolean active = FALSE;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = (NetworkWifiInterface*) base;
	_tmp0_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_switch_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	active = _tmp3_;
	if (active == self->priv->software_locked) {
		RFKillManager* _tmp4_;
		NetworkNetworkManager* network_manager = NULL;
		NetworkNetworkManager* _tmp5_;
		NetworkNetworkManager* _tmp6_;
		NMClient* _tmp7_;
		NMClient* _tmp8_;
		_tmp4_ = self->priv->rfkill;
		rf_kill_manager_set_software_lock (_tmp4_, RF_KILL_DEVICE_TYPE_WLAN, !active);
		_tmp5_ = network_network_manager_get_default ();
		network_manager = _tmp5_;
		_tmp6_ = network_manager;
		_tmp7_ = network_network_manager_get_client (_tmp6_);
		_tmp8_ = _tmp7_;
		nm_client_wireless_set_enabled (_tmp8_, active);
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data9_->self;
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
	return self ? g_ptr_array_ref (self) : NULL;
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data10_->_data9_->self;
		_g_object_unref0 (_data10_->wifi_dialog);
		block9_data_unref (_data10_->_data9_);
		_data10_->_data9_ = NULL;
		g_slice_free (Block10Data, _data10_);
	}
}

static void
___lambda20_ (Block10Data* _data10_,
              gint response)
{
	Block9Data* _data9_;
	NetworkWifiInterface* self;
	NMAWifiDialog* _tmp1_;
	_data9_ = _data10_->_data9_;
	self = _data9_->self;
	if (response == ((gint) GTK_RESPONSE_OK)) {
		NMAWifiDialog* _tmp0_;
		_tmp0_ = _data10_->wifi_dialog;
		network_wifi_interface_connect_to_network (self, _tmp0_, NULL, NULL);
	}
	_tmp1_ = _data10_->wifi_dialog;
	gtk_window_destroy ((GtkWindow*) _tmp1_);
}

static void
____lambda20__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
	___lambda20_ (self, response_id);
}

static gpointer
_g_bytes_ref0 (gpointer self)
{
	return self ? g_bytes_ref (self) : NULL;
}

static void
___lambda22_ (Block9Data* _data9_,
              GObject* obj,
              GAsyncResult* res)
{
	NetworkWifiInterface* self;
	GError* _inner_error0_ = NULL;
	self = _data9_->self;
	g_return_if_fail (res != NULL);
	{
		NMClient* _tmp0_;
		NMActiveConnection* _tmp1_;
		NMActiveConnection* _tmp2_;
		_tmp0_ = _data9_->client;
		_tmp1_ = nm_client_add_and_activate_connection_finish (_tmp0_, res, &_inner_error0_);
		_tmp2_ = _tmp1_;
		_g_object_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = _error_;
		_tmp4_ = _tmp3_->message;
		g_warning ("WifiPage.vala:576: %s", _tmp4_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda22__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda22_ (self, source_object, res);
	block9_data_unref (self);
}

static gboolean
__lambda23_ (NetworkWifiInterface* self)
{
	gboolean result;
	network_widgets_page_update ((NetworkWidgetsPage*) self);
	result = FALSE;
	return result;
}

static gboolean
___lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda23_ ((NetworkWifiInterface*) self);
	return result;
}

static void
network_wifi_interface_wifi_activate_cb (NetworkWifiInterface* self,
                                         NetworkWifiMenuItem* row)
{
	Block9Data* _data9_;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
	NMDeviceWifi* _tmp2_;
	NMAccessPoint* _tmp3_;
	NMAccessPoint* _tmp4_;
	NMAccessPoint* _tmp5_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp6_;
	NetworkNetworkManager* _tmp7_;
	NMClient* _tmp8_;
	NMClient* _tmp9_;
	GPtrArray* connections = NULL;
	NMClient* _tmp10_;
	GPtrArray* _tmp11_;
	GPtrArray* _tmp12_;
	GPtrArray* device_connections = NULL;
	NMDeviceWifi* _tmp13_;
	GPtrArray* _tmp14_;
	GPtrArray* _tmp15_;
	GPtrArray* ap_connections = NULL;
	NMAccessPoint* _tmp16_;
	NMAccessPoint* _tmp17_;
	GPtrArray* _tmp18_;
	GPtrArray* _tmp19_;
	NMConnection* valid_connection = NULL;
	NMAccessPoint* _tmp20_;
	NMAccessPoint* _tmp21_;
	GPtrArray* _tmp22_;
	NMConnection* _tmp23_;
	NMConnection* _tmp24_;
	NMConnection* connection = NULL;
	NMConnection* _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (row != NULL);
	_data9_ = g_slice_new0 (Block9Data);
	_data9_->_ref_count_ = 1;
	_data9_->self = g_object_ref (self);
	_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		block9_data_unref (_data9_);
		_data9_ = NULL;
		return;
	}
	_tmp2_ = self->wifi_device;
	_tmp3_ = nm_device_wifi_get_active_access_point (_tmp2_);
	_tmp4_ = network_wifi_menu_item_get_ap (row);
	_tmp5_ = _tmp4_;
	if (_tmp3_ == _tmp5_) {
		block9_data_unref (_data9_);
		_data9_ = NULL;
		return;
	}
	_tmp6_ = network_network_manager_get_default ();
	network_manager = _tmp6_;
	_tmp7_ = network_manager;
	_tmp8_ = network_network_manager_get_client (_tmp7_);
	_tmp9_ = _tmp8_;
	_data9_->client = _tmp9_;
	_tmp10_ = _data9_->client;
	_tmp11_ = nm_client_get_connections (_tmp10_);
	_tmp12_ = _g_ptr_array_ref0 (_tmp11_);
	connections = _tmp12_;
	_tmp13_ = self->wifi_device;
	_tmp14_ = connections;
	_tmp15_ = nm_device_filter_connections ((NMDevice*) _tmp13_, _tmp14_);
	device_connections = _tmp15_;
	_tmp16_ = network_wifi_menu_item_get_ap (row);
	_tmp17_ = _tmp16_;
	_tmp18_ = device_connections;
	_tmp19_ = nm_access_point_filter_connections (_tmp17_, _tmp18_);
	ap_connections = _tmp19_;
	_tmp20_ = network_wifi_menu_item_get_ap (row);
	_tmp21_ = _tmp20_;
	_tmp22_ = ap_connections;
	_tmp23_ = network_wifi_interface_get_valid_connection (self, _tmp21_, _tmp22_);
	valid_connection = _tmp23_;
	_tmp24_ = valid_connection;
	if (_tmp24_ != NULL) {
		NMClient* _tmp25_;
		NMConnection* _tmp26_;
		NMDeviceWifi* _tmp27_;
		NMAccessPoint* _tmp28_;
		NMAccessPoint* _tmp29_;
		const gchar* _tmp30_;
		_tmp25_ = _data9_->client;
		_tmp26_ = valid_connection;
		_tmp27_ = self->wifi_device;
		_tmp28_ = network_wifi_menu_item_get_ap (row);
		_tmp29_ = _tmp28_;
		_tmp30_ = nm_object_get_path ((NMObject*) _tmp29_);
		nm_client_activate_connection_async (_tmp25_, _tmp26_, (NMDevice*) _tmp27_, _tmp30_, NULL, NULL, NULL);
		_g_object_unref0 (valid_connection);
		_g_ptr_array_unref0 (ap_connections);
		_g_ptr_array_unref0 (device_connections);
		_g_ptr_array_unref0 (connections);
		block9_data_unref (_data9_);
		_data9_ = NULL;
		return;
	}
	_tmp31_ = nm_simple_connection_new ();
	connection = _tmp31_;
	_tmp32_ = network_wifi_menu_item_get_is_secured (row);
	_tmp33_ = _tmp32_;
	if (_tmp33_) {
		Block10Data* _data10_;
		NMSettingConnection* s_con = NULL;
		gchar* _tmp34_;
		NMSettingConnection* _tmp35_ = NULL;
		NMConnection* _tmp36_;
		NMSettingConnection* _tmp37_;
		NMSetting* _tmp38_;
		gboolean _tmp39_ = FALSE;
		NMAccessPoint* _tmp40_;
		NMAccessPoint* _tmp41_;
		NMSettingWireless* s_wifi = NULL;
		NMSettingWireless* _tmp49_;
		NMSettingWireless* _tmp50_;
		NMAccessPoint* _tmp51_;
		NMAccessPoint* _tmp52_;
		GBytes* _tmp53_;
		NMConnection* _tmp54_;
		NMSettingWireless* _tmp55_;
		NMSetting* _tmp56_;
		gboolean _tmp57_ = FALSE;
		NMAccessPoint* _tmp58_;
		NMAccessPoint* _tmp59_;
		NMClient* _tmp73_;
		NMConnection* _tmp74_;
		NMDeviceWifi* _tmp75_;
		NMAccessPoint* _tmp76_;
		NMAccessPoint* _tmp77_;
		GtkRoot* _tmp78_;
		GtkWindow* _tmp79_;
		NMAWifiDialog* _tmp80_ = NULL;
		NMAWifiDialog* _tmp81_;
		NMAWifiDialog* _tmp82_;
		_data10_ = g_slice_new0 (Block10Data);
		_data10_->_ref_count_ = 1;
		_data10_->_data9_ = block9_data_ref (_data9_);
		_tmp34_ = nm_utils_uuid_generate ();
		_tmp35_ = (NMSettingConnection*) nm_setting_connection_new ();
		g_object_set (_tmp35_, "uuid", _tmp34_, NULL);
		_g_free0 (_tmp34_);
		s_con = _tmp35_;
		_tmp36_ = connection;
		_tmp37_ = s_con;
		_tmp38_ = _g_object_ref0 ((NMSetting*) _tmp37_);
		nm_connection_add_setting (_tmp36_, _tmp38_);
		_tmp40_ = network_wifi_menu_item_get_ap (row);
		_tmp41_ = _tmp40_;
		if ((nm_access_point_get_rsn_flags (_tmp41_) & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE) {
			_tmp39_ = TRUE;
		} else {
			NMAccessPoint* _tmp42_;
			NMAccessPoint* _tmp43_;
			_tmp42_ = network_wifi_menu_item_get_ap (row);
			_tmp43_ = _tmp42_;
			_tmp39_ = (nm_access_point_get_wpa_flags (_tmp43_) & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE;
		}
		if (_tmp39_) {
			NMSettingWirelessSecurity* s_wsec = NULL;
			NMSettingWirelessSecurity* _tmp44_;
			NMSettingWirelessSecurity* _tmp45_;
			NMConnection* _tmp46_;
			NMSettingWirelessSecurity* _tmp47_;
			NMSetting* _tmp48_;
			_tmp44_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
			s_wsec = _tmp44_;
			_tmp45_ = s_wsec;
			g_object_set (_tmp45_, "key-mgmt", "sae", NULL);
			_tmp46_ = connection;
			_tmp47_ = s_wsec;
			_tmp48_ = _g_object_ref0 ((NMSetting*) _tmp47_);
			nm_connection_add_setting (_tmp46_, _tmp48_);
			_g_object_unref0 (s_wsec);
		}
		_tmp49_ = (NMSettingWireless*) nm_setting_wireless_new ();
		s_wifi = _tmp49_;
		_tmp50_ = s_wifi;
		_tmp51_ = network_wifi_menu_item_get_ap (row);
		_tmp52_ = _tmp51_;
		_tmp53_ = nm_access_point_get_ssid (_tmp52_);
		g_object_set (_tmp50_, "ssid", _tmp53_, NULL);
		_tmp54_ = connection;
		_tmp55_ = s_wifi;
		_tmp56_ = _g_object_ref0 ((NMSetting*) _tmp55_);
		nm_connection_add_setting (_tmp54_, _tmp56_);
		_tmp58_ = network_wifi_menu_item_get_ap (row);
		_tmp59_ = _tmp58_;
		if ((nm_access_point_get_rsn_flags (_tmp59_) & NM_802_11_AP_SEC_KEY_MGMT_802_1X) == NM_802_11_AP_SEC_KEY_MGMT_802_1X) {
			_tmp57_ = TRUE;
		} else {
			NMAccessPoint* _tmp60_;
			NMAccessPoint* _tmp61_;
			_tmp60_ = network_wifi_menu_item_get_ap (row);
			_tmp61_ = _tmp60_;
			_tmp57_ = (nm_access_point_get_wpa_flags (_tmp61_) & NM_802_11_AP_SEC_KEY_MGMT_802_1X) == NM_802_11_AP_SEC_KEY_MGMT_802_1X;
		}
		if (_tmp57_) {
			NMSettingWirelessSecurity* s_wsec = NULL;
			gchar* _tmp62_;
			NMSettingWirelessSecurity* _tmp63_ = NULL;
			NMConnection* _tmp64_;
			NMSettingWirelessSecurity* _tmp65_;
			NMSetting* _tmp66_;
			NMSetting8021x* s_8021x = NULL;
			NMSetting8021x* _tmp67_;
			NMSetting8021x* _tmp68_;
			NMSetting8021x* _tmp69_;
			NMConnection* _tmp70_;
			NMSetting8021x* _tmp71_;
			NMSetting* _tmp72_;
			_tmp62_ = g_strdup ("wpa-eap");
			_tmp63_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
			g_object_set (_tmp63_, "key-mgmt", _tmp62_, NULL);
			_g_free0 (_tmp62_);
			s_wsec = _tmp63_;
			_tmp64_ = connection;
			_tmp65_ = s_wsec;
			_tmp66_ = _g_object_ref0 ((NMSetting*) _tmp65_);
			nm_connection_add_setting (_tmp64_, _tmp66_);
			_tmp67_ = (NMSetting8021x*) nm_setting_802_1x_new ();
			s_8021x = _tmp67_;
			_tmp68_ = s_8021x;
			nm_setting_802_1x_add_eap_method (_tmp68_, "ttls");
			_tmp69_ = s_8021x;
			g_object_set (_tmp69_, "phase2-auth", "mschapv2", NULL);
			_tmp70_ = connection;
			_tmp71_ = s_8021x;
			_tmp72_ = _g_object_ref0 ((NMSetting*) _tmp71_);
			nm_connection_add_setting (_tmp70_, _tmp72_);
			_g_object_unref0 (s_8021x);
			_g_object_unref0 (s_wsec);
		}
		_tmp73_ = _data9_->client;
		_tmp74_ = connection;
		_tmp75_ = self->wifi_device;
		_tmp76_ = network_wifi_menu_item_get_ap (row);
		_tmp77_ = _tmp76_;
		_tmp78_ = gtk_widget_get_root ((GtkWidget*) self);
		_tmp79_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, gtk_window_get_type (), GtkWindow));
		_tmp80_ = (NMAWifiDialog*) nma_wifi_dialog_new (_tmp73_, _tmp74_, (NMDevice*) _tmp75_, _tmp77_, FALSE);
		gtk_window_set_deletable ((GtkWindow*) _tmp80_, FALSE);
		gtk_window_set_modal ((GtkWindow*) _tmp80_, TRUE);
		gtk_window_set_transient_for ((GtkWindow*) _tmp80_, _tmp79_);
		_g_object_unref0 (_tmp79_);
		g_object_ref_sink (_tmp80_);
		_data10_->wifi_dialog = _tmp80_;
		_tmp81_ = _data10_->wifi_dialog;
		gtk_window_present ((GtkWindow*) _tmp81_);
		_tmp82_ = _data10_->wifi_dialog;
		g_signal_connect_data ((GtkDialog*) _tmp82_, "response", (GCallback) ____lambda20__gtk_dialog_response, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
		_g_object_unref0 (s_wifi);
		_g_object_unref0 (s_con);
		block10_data_unref (_data10_);
		_data10_ = NULL;
	} else {
		gboolean _tmp83_ = FALSE;
		NMAccessPoint* _tmp84_;
		NMAccessPoint* _tmp85_;
		NMClient* _tmp106_;
		NMConnection* _tmp107_;
		NMDeviceWifi* _tmp108_;
		NMAccessPoint* _tmp109_;
		NMAccessPoint* _tmp110_;
		const gchar* _tmp111_;
		_tmp84_ = network_wifi_menu_item_get_ap (row);
		_tmp85_ = _tmp84_;
		if ((nm_access_point_get_rsn_flags (_tmp85_) & NM_802_11_AP_SEC_KEY_MGMT_OWE) == NM_802_11_AP_SEC_KEY_MGMT_OWE) {
			_tmp83_ = TRUE;
		} else {
			NMAccessPoint* _tmp86_;
			NMAccessPoint* _tmp87_;
			_tmp86_ = network_wifi_menu_item_get_ap (row);
			_tmp87_ = _tmp86_;
			_tmp83_ = (nm_access_point_get_wpa_flags (_tmp87_) & NM_802_11_AP_SEC_KEY_MGMT_OWE) == NM_802_11_AP_SEC_KEY_MGMT_OWE;
		}
		if (_tmp83_) {
			NMSettingConnection* s_con = NULL;
			gchar* _tmp88_;
			NMSettingConnection* _tmp89_ = NULL;
			NMConnection* _tmp90_;
			NMSettingConnection* _tmp91_;
			NMSetting* _tmp92_;
			NMSettingWirelessSecurity* s_wsec = NULL;
			gchar* _tmp93_;
			NMSettingWirelessSecurity* _tmp94_ = NULL;
			NMConnection* _tmp95_;
			NMSettingWirelessSecurity* _tmp96_;
			NMSetting* _tmp97_;
			NMSettingWireless* s_wifi = NULL;
			NMAccessPoint* _tmp98_;
			NMAccessPoint* _tmp99_;
			GBytes* _tmp100_;
			GBytes* _tmp101_;
			NMSettingWireless* _tmp102_ = NULL;
			NMConnection* _tmp103_;
			NMSettingWireless* _tmp104_;
			NMSetting* _tmp105_;
			_tmp88_ = nm_utils_uuid_generate ();
			_tmp89_ = (NMSettingConnection*) nm_setting_connection_new ();
			g_object_set (_tmp89_, "uuid", _tmp88_, NULL);
			_g_free0 (_tmp88_);
			s_con = _tmp89_;
			_tmp90_ = connection;
			_tmp91_ = s_con;
			_tmp92_ = _g_object_ref0 ((NMSetting*) _tmp91_);
			nm_connection_add_setting (_tmp90_, _tmp92_);
			_tmp93_ = g_strdup ("owe");
			_tmp94_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
			g_object_set (_tmp94_, "key-mgmt", _tmp93_, NULL);
			_g_free0 (_tmp93_);
			s_wsec = _tmp94_;
			_tmp95_ = connection;
			_tmp96_ = s_wsec;
			_tmp97_ = _g_object_ref0 ((NMSetting*) _tmp96_);
			nm_connection_add_setting (_tmp95_, _tmp97_);
			_tmp98_ = network_wifi_menu_item_get_ap (row);
			_tmp99_ = _tmp98_;
			_tmp100_ = nm_access_point_get_ssid (_tmp99_);
			_tmp101_ = _g_bytes_ref0 (_tmp100_);
			_tmp102_ = (NMSettingWireless*) nm_setting_wireless_new ();
			g_object_set (_tmp102_, "ssid", _tmp101_, NULL);
			_g_bytes_unref0 (_tmp101_);
			s_wifi = _tmp102_;
			_tmp103_ = connection;
			_tmp104_ = s_wifi;
			_tmp105_ = _g_object_ref0 ((NMSetting*) _tmp104_);
			nm_connection_add_setting (_tmp103_, _tmp105_);
			_g_object_unref0 (s_wifi);
			_g_object_unref0 (s_wsec);
			_g_object_unref0 (s_con);
		}
		_tmp106_ = _data9_->client;
		_tmp107_ = connection;
		_tmp108_ = self->wifi_device;
		_tmp109_ = network_wifi_menu_item_get_ap (row);
		_tmp110_ = _tmp109_;
		_tmp111_ = nm_object_get_path ((NMObject*) _tmp110_);
		nm_client_add_and_activate_connection_async (_tmp106_, _tmp107_, (NMDevice*) _tmp108_, _tmp111_, NULL, ____lambda22__gasync_ready_callback, block9_data_ref (_data9_));
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda23__gsource_func, g_object_ref (self), g_object_unref);
	_g_object_unref0 (connection);
	_g_object_unref0 (valid_connection);
	_g_ptr_array_unref0 (ap_connections);
	_g_ptr_array_unref0 (device_connections);
	_g_ptr_array_unref0 (connections);
	block9_data_unref (_data9_);
	_data9_ = NULL;
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static NMConnection*
network_wifi_interface_get_valid_connection (NetworkWifiInterface* self,
                                             NMAccessPoint* ap,
                                             GPtrArray* ap_connections)
{
	NMConnection* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (ap != NULL, NULL);
	g_return_val_if_fail (ap_connections != NULL, NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				NMConnection* connection = NULL;
				gconstpointer _tmp4_;
				NMConnection* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = vala_g_ptr_array_get_length (ap_connections);
				_tmp3_ = _tmp2_;
				if (!(i < _tmp3_)) {
					break;
				}
				_tmp4_ = g_ptr_array_index (ap_connections, (guint) i);
				connection = (NMConnection*) _tmp4_;
				_tmp5_ = connection;
				if (nm_access_point_connection_valid (ap, _tmp5_)) {
					NMConnection* _tmp6_;
					NMConnection* _tmp7_;
					_tmp6_ = connection;
					_tmp7_ = _g_object_ref0 (_tmp6_);
					result = _tmp7_;
					return result;
				}
			}
		}
	}
	result = NULL;
	return result;
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data11_->self;
		_g_object_unref0 (_data11_->hidden_dialog);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static void
__lambda26_ (Block11Data* _data11_,
             gint response)
{
	NetworkWifiInterface* self;
	self = _data11_->self;
	if (response == ((gint) GTK_RESPONSE_OK)) {
		network_wifi_interface_connect_to_network (self, _data11_->hidden_dialog, NULL, NULL);
	}
	gtk_window_destroy ((GtkWindow*) _data11_->hidden_dialog);
}

static void
___lambda26__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda26_ (self, response_id);
}

static void
network_wifi_interface_connect_to_hidden (NetworkWifiInterface* self)
{
	Block11Data* _data11_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp0_;
	NMClient* _tmp1_;
	NMClient* _tmp2_;
	GtkRoot* _tmp3_;
	GtkWindow* _tmp4_;
	NMAWifiDialog* _tmp5_ = NULL;
	g_return_if_fail (self != NULL);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_data11_->self = g_object_ref (self);
	_tmp0_ = network_network_manager_get_default ();
	network_manager = _tmp0_;
	_tmp1_ = network_network_manager_get_client (network_manager);
	_tmp2_ = _tmp1_;
	_tmp3_ = gtk_widget_get_root ((GtkWidget*) self);
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow));
	_tmp5_ = (NMAWifiDialog*) nma_wifi_dialog_new_for_other (_tmp2_);
	gtk_window_set_deletable ((GtkWindow*) _tmp5_, FALSE);
	gtk_window_set_modal ((GtkWindow*) _tmp5_, TRUE);
	gtk_window_set_transient_for ((GtkWindow*) _tmp5_, _tmp4_);
	_g_object_unref0 (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_data11_->hidden_dialog = _tmp5_;
	gtk_window_present ((GtkWindow*) _data11_->hidden_dialog);
	g_signal_connect_data ((GtkDialog*) _data11_->hidden_dialog, "response", (GCallback) ___lambda26__gtk_dialog_response, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	block11_data_unref (_data11_);
	_data11_ = NULL;
}

static void
network_wifi_interface_connect_to_network_data_free (gpointer _data)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->wifi_dialog);
	_g_object_unref0 (_data_->self);
	g_slice_free (NetworkWifiInterfaceConnectToNetworkData, _data_);
}

static void
network_wifi_interface_connect_to_network (NetworkWifiInterface* self,
                                           NMAWifiDialog* wifi_dialog,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	NetworkWifiInterface* _tmp0_;
	NMAWifiDialog* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (wifi_dialog != NULL);
	_data_ = g_slice_new0 (NetworkWifiInterfaceConnectToNetworkData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, network_wifi_interface_connect_to_network_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (wifi_dialog);
	_g_object_unref0 (_data_->wifi_dialog);
	_data_->wifi_dialog = _tmp1_;
	network_wifi_interface_connect_to_network_co (_data_);
}

static void
network_wifi_interface_connect_to_network_finish (NetworkWifiInterface* self,
                                                  GAsyncResult* _res_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
	g_atomic_int_inc (&_data12_->_ref_count_);
	return _data12_;
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data12_->self;
		_g_object_unref0 (_data12_->dialog_connection);
		_g_object_unref0 (_data12_->fuzzy);
		_g_object_unref0 (self);
		g_slice_free (Block12Data, _data12_);
	}
}

static void
__lambda21_ (Block12Data* _data12_,
             NMRemoteConnection* possible)
{
	NetworkWifiInterface* self;
	NMConnection* _tmp0_;
	self = _data12_->self;
	g_return_if_fail (possible != NULL);
	_tmp0_ = _data12_->dialog_connection;
	if (nm_connection_compare (_tmp0_, (NMConnection*) possible, NM_SETTING_COMPARE_FLAG_FUZZY | NM_SETTING_COMPARE_FLAG_IGNORE_ID)) {
		NMConnection* _tmp1_;
		_tmp1_ = _g_object_ref0 ((NMConnection*) possible);
		_g_object_unref0 (_data12_->fuzzy);
		_data12_->fuzzy = _tmp1_;
	}
}

static void
___lambda21__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda21_ (self, (NMRemoteConnection*) data);
}

static void
network_wifi_interface_connect_to_network_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	network_wifi_interface_connect_to_network_co (_data_);
}

static gboolean
network_wifi_interface_connect_to_network_co (NetworkWifiInterfaceConnectToNetworkData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data12_ = g_slice_new0 (Block12Data);
	_data_->_data12_->_ref_count_ = 1;
	_data_->_data12_->self = g_object_ref (_data_->self);
	_data_->_data12_->_async_data_ = _data_;
	_data_->_data12_->fuzzy = NULL;
	_data_->dialog_ap = NULL;
	_data_->_tmp0_ = NULL;
	_data_->_tmp1_ = NULL;
	_data_->_tmp2_ = nma_wifi_dialog_get_connection (_data_->wifi_dialog, &_data_->_tmp0_, &_data_->_tmp1_);
	_g_object_unref0 (_data_->dialog_device);
	_data_->dialog_device = _data_->_tmp0_;
	_g_object_unref0 (_data_->dialog_ap);
	_data_->dialog_ap = _data_->_tmp1_;
	_data_->_data12_->dialog_connection = _data_->_tmp2_;
	_data_->_tmp3_ = network_network_manager_get_default ();
	_data_->network_manager = _data_->_tmp3_;
	_data_->_tmp4_ = _data_->network_manager;
	_data_->_tmp5_ = network_network_manager_get_client (_data_->_tmp4_);
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->client = _data_->_tmp6_;
	_data_->_tmp7_ = _data_->client;
	_data_->_tmp8_ = nm_client_get_connections (_data_->_tmp7_);
	g_ptr_array_foreach (_data_->_tmp8_, ___lambda21__gfunc, _data_->_data12_);
	_data_->path = NULL;
	_data_->_tmp9_ = _data_->dialog_ap;
	if (_data_->_tmp9_ != NULL) {
		_data_->_tmp10_ = _data_->dialog_ap;
		_data_->_tmp11_ = nm_object_get_path ((NMObject*) _data_->_tmp10_);
		_data_->_tmp12_ = g_strdup (_data_->_tmp11_);
		_g_free0 (_data_->path);
		_data_->path = _data_->_tmp12_;
	}
	_data_->_tmp13_ = _data_->_data12_->fuzzy;
	if (_data_->_tmp13_ != NULL) {
		{
			_data_->_tmp14_ = _data_->client;
			_data_->_tmp15_ = _data_->_data12_->fuzzy;
			_data_->_tmp16_ = _data_->self->wifi_device;
			_data_->_tmp17_ = _data_->path;
			_data_->_state_ = 1;
			nm_client_activate_connection_async (_data_->_tmp14_, _data_->_tmp15_, (NMDevice*) _data_->_tmp16_, _data_->_tmp17_, NULL, network_wifi_interface_connect_to_network_ready, _data_);
			return FALSE;
			_state_1:
			_data_->_tmp18_ = nm_client_activate_connection_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp19_ = _data_->_tmp18_;
			_g_object_unref0 (_data_->_tmp19_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->_error_ = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp20_ = _data_->_error_;
			_data_->_tmp21_ = _data_->_tmp20_->message;
			g_critical ("WifiPage.vala:640: %s", _data_->_tmp21_);
			_g_error_free0 (_data_->_error_);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->path);
			_g_object_unref0 (_data_->dialog_ap);
			_g_object_unref0 (_data_->dialog_device);
			block12_data_unref (_data_->_data12_);
			_data_->_data12_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	} else {
		_data_->mode = NULL;
		_data_->_tmp22_ = _data_->_data12_->dialog_connection;
		_data_->_tmp23_ = nm_connection_get_setting_wireless (_data_->_tmp22_);
		_data_->setting_wireless = _data_->_tmp23_;
		_data_->_tmp24_ = _data_->setting_wireless;
		if (_data_->_tmp24_ != NULL) {
			_data_->_tmp25_ = _data_->setting_wireless;
			_data_->_tmp26_ = nm_setting_wireless_get_mode (_data_->_tmp25_);
			_data_->_tmp27_ = g_strdup (_data_->_tmp26_);
			_g_free0 (_data_->mode);
			_data_->mode = _data_->_tmp27_;
		}
		_data_->_tmp28_ = _data_->mode;
		if (g_strcmp0 (_data_->_tmp28_, "adhoc") == 0) {
			_data_->_tmp29_ = _data_->_data12_->dialog_connection;
			_data_->_tmp30_ = nm_connection_get_setting_connection (_data_->_tmp29_);
			_data_->_tmp31_ = _g_object_ref0 (_data_->_tmp30_);
			_data_->connection_setting = _data_->_tmp31_;
			_data_->_tmp32_ = _data_->connection_setting;
			if (_data_->_tmp32_ == NULL) {
				_data_->_tmp33_ = (NMSettingConnection*) nm_setting_connection_new ();
				_g_object_unref0 (_data_->connection_setting);
				_data_->connection_setting = _data_->_tmp33_;
			}
			_data_->_tmp34_ = _data_->_data12_->dialog_connection;
			_data_->_tmp35_ = _data_->connection_setting;
			_data_->_tmp36_ = _g_object_ref0 ((NMSetting*) _data_->_tmp35_);
			nm_connection_add_setting (_data_->_tmp34_, _data_->_tmp36_);
			_g_object_unref0 (_data_->connection_setting);
		}
		{
			_data_->_tmp37_ = _data_->client;
			_data_->_tmp38_ = _data_->_data12_->dialog_connection;
			_data_->_tmp39_ = _data_->dialog_device;
			_data_->_tmp40_ = _data_->path;
			_data_->_state_ = 2;
			nm_client_add_and_activate_connection_async (_data_->_tmp37_, _data_->_tmp38_, _data_->_tmp39_, _data_->_tmp40_, NULL, network_wifi_interface_connect_to_network_ready, _data_);
			return FALSE;
			_state_2:
			_data_->_tmp41_ = nm_client_add_and_activate_connection_finish (_data_->_tmp37_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp42_ = _data_->_tmp41_;
			_g_object_unref0 (_data_->_tmp42_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			_data_->_vala1__error_ = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp43_ = _data_->_vala1__error_;
			_data_->_tmp44_ = _data_->_tmp43_->message;
			g_critical ("WifiPage.vala:661: %s", _data_->_tmp44_);
			_g_error_free0 (_data_->_vala1__error_);
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->mode);
			_g_free0 (_data_->path);
			_g_object_unref0 (_data_->dialog_ap);
			_g_object_unref0 (_data_->dialog_device);
			block12_data_unref (_data_->_data12_);
			_data_->_data12_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_free0 (_data_->mode);
	}
	_g_free0 (_data_->path);
	_g_object_unref0 (_data_->dialog_ap);
	_g_object_unref0 (_data_->dialog_device);
	block12_data_unref (_data_->_data12_);
	_data_->_data12_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
network_wifi_interface_cancel_scan (NetworkWifiInterface* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->timeout_scan > ((guint) 0)) {
		g_source_remove (self->priv->timeout_scan);
		self->priv->timeout_scan = (guint) 0;
	}
}

static gboolean
___lambda24_ (NetworkWifiInterface* self)
{
	NMDeviceWifi* _tmp0_;
	GtkStack* _tmp1_;
	gboolean result;
	_tmp0_ = self->wifi_device;
	if (network_utils_get_device_is_hotspot (_tmp0_)) {
		result = FALSE;
		return result;
	}
	self->priv->timeout_scan = (guint) 0;
	_tmp1_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp1_, "no-aps");
	result = FALSE;
	return result;
}

static gboolean
____lambda24__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda24_ ((NetworkWifiInterface*) self);
	return result;
}

static void
network_wifi_interface_set_scan_placeholder (NetworkWifiInterface* self)
{
	NMDeviceState _tmp0_;
	NMDeviceState _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NM_DEVICE_STATE_DISCONNECTED) {
		GtkStack* _tmp2_;
		NMDeviceWifi* _tmp3_;
		_tmp2_ = self->priv->placeholder;
		gtk_stack_set_visible_child_name (_tmp2_, "scanning");
		network_wifi_interface_cancel_scan (self);
		_tmp3_ = self->wifi_device;
		nm_device_wifi_request_scan_async (_tmp3_, NULL, NULL, NULL);
		self->priv->timeout_scan = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 5000, ____lambda24__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static gint
network_wifi_interface_sort_func (NetworkWifiInterface* self,
                                  GtkListBoxRow* r1,
                                  GtkListBoxRow* r2)
{
	gboolean _tmp0_ = FALSE;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	NMAccessPoint* _tmp5_;
	NMAccessPoint* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (r1 != NULL, 0);
	g_return_val_if_fail (r2 != NULL, 0);
	if (r1 == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = r2 == NULL;
	}
	if (_tmp0_) {
		result = 0;
		return result;
	}
	_tmp1_ = network_wifi_menu_item_get_ap (G_TYPE_CHECK_INSTANCE_CAST (r2, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
	_tmp2_ = _tmp1_;
	_tmp3_ = nm_access_point_get_strength (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = network_wifi_menu_item_get_ap (G_TYPE_CHECK_INSTANCE_CAST (r1, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
	_tmp6_ = _tmp5_;
	_tmp7_ = nm_access_point_get_strength (_tmp6_);
	_tmp8_ = _tmp7_;
	result = (gint) (_tmp4_ - _tmp8_);
	return result;
}

static NetworkWifiMenuItem*
network_wifi_interface_get_active_wifi_item (NetworkWifiInterface* self)
{
	NetworkWifiMenuItem* result;
	NetworkWifiMenuItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_active_wifi_item;
	result = _tmp0_;
	return result;
}

static void
network_wifi_interface_set_active_wifi_item (NetworkWifiInterface* self,
                                             NetworkWifiMenuItem* value)
{
	NetworkWifiMenuItem* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_active_wifi_item);
	self->priv->_active_wifi_item = _tmp0_;
}

static gint
_network_wifi_interface_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                          GtkListBoxRow* row2,
                                                          gpointer self)
{
	gint result;
	result = network_wifi_interface_sort_func ((NetworkWifiInterface*) self, row1, row2);
	return result;
}

static void
_network_widgets_page_edit_connections_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
	network_widgets_page_edit_connections ((NetworkWidgetsPage*) self);
}

static void
_network_wifi_interface_connect_to_hidden_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
	network_wifi_interface_connect_to_hidden ((NetworkWifiInterface*) self);
}

static void
_network_widgets_page_update_rf_kill_manager_device_added (RFKillManager* _sender,
                                                           RFKillDevice* device,
                                                           gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_widgets_page_update_rf_kill_manager_device_changed (RFKillManager* _sender,
                                                             RFKillDevice* device,
                                                             gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_widgets_page_update_rf_kill_manager_device_deleted (RFKillManager* _sender,
                                                             RFKillDevice* device,
                                                             gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_widgets_page_update_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added (NMDeviceWifi* _sender,
                                                                                 GObject* ap,
                                                                                 gpointer self)
{
	network_wifi_interface_access_point_added_cb ((NetworkWifiInterface*) self, ap);
}

static void
_network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed (NMDeviceWifi* _sender,
                                                                                     GObject* ap,
                                                                                     gpointer self)
{
	network_wifi_interface_access_point_removed_cb ((NetworkWifiInterface*) self, ap);
}

static void
_network_widgets_page_update_nm_device_state_changed (NMDevice* _sender,
                                                      guint new_state,
                                                      guint old_state,
                                                      guint reason,
                                                      gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_wifi_interface_access_point_added_cb_gfunc (gconstpointer data,
                                                     gpointer self)
{
	network_wifi_interface_access_point_added_cb ((NetworkWifiInterface*) self, (GObject*) data);
}

static GObject *
network_wifi_interface_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWifiInterface * self;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GtkStack* _tmp2_ = NULL;
	GtkListBox* _tmp3_ = NULL;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkStack* _tmp6_;
	GtkListBox* _tmp7_;
	GranitePlaceholder* hotspot_mode_alert = NULL;
	gchar* _tmp8_;
	GranitePlaceholder* _tmp9_ = NULL;
	GtkListBox* _tmp10_;
	GtkWidget* _tmp11_;
	GtkScrolledWindow* _tmp12_ = NULL;
	GtkStack* _tmp13_;
	GtkStack* _tmp14_;
	GranitePlaceholder* _tmp15_;
	GtkStack* _tmp16_;
	GtkScrolledWindow* _tmp17_;
	GtkStack* _tmp18_;
	GtkScrolledWindow* _tmp19_;
	GtkFrame* main_frame = NULL;
	GtkStack* _tmp20_;
	GtkWidget* _tmp21_;
	GtkFrame* _tmp22_ = NULL;
	GtkFrame* _tmp23_;
	NetworkWidgetsInfoBox* _tmp24_;
	NetworkWidgetsInfoBox* _tmp25_;
	NetworkWidgetsInfoBox* _tmp26_;
	NetworkWidgetsInfoBox* _tmp27_;
	NetworkWidgetsInfoBox* _tmp28_;
	GtkWidget* _tmp29_;
	GtkPopover* _tmp30_ = NULL;
	GtkFrame* _tmp31_ = NULL;
	GtkFrame* _tmp32_;
	GtkWidget* _tmp33_;
	GtkRevealer* _tmp34_ = NULL;
	GtkButton* settings_button = NULL;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	NMDevice* _tmp39_;
	NMDevice* _tmp40_;
	NMDeviceWifi* _tmp41_;
	GranitePlaceholder* no_aps_alert = NULL;
	gchar* _tmp42_;
	GranitePlaceholder* _tmp43_ = NULL;
	GranitePlaceholder* wireless_off_alert = NULL;
	gchar* _tmp44_;
	GranitePlaceholder* _tmp45_ = NULL;
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp46_ = NULL;
	GtkSpinner* _tmp47_;
	GtkLabel* scanning = NULL;
	GtkLabel* _tmp48_ = NULL;
	GtkLabel* _tmp49_;
	GtkBox* scanning_box = NULL;
	GtkBox* _tmp50_ = NULL;
	GtkBox* _tmp51_;
	GtkLabel* _tmp52_;
	GtkBox* _tmp53_;
	GtkSpinner* _tmp54_;
	GtkStack* _tmp55_;
	GranitePlaceholder* _tmp56_;
	GtkStack* _tmp57_;
	GranitePlaceholder* _tmp58_;
	GtkStack* _tmp59_;
	GtkBox* _tmp60_;
	GtkStack* _tmp61_;
	RFKillManager* _tmp62_;
	RFKillManager* _tmp63_;
	RFKillManager* _tmp64_;
	RFKillManager* _tmp65_;
	RFKillManager* _tmp66_;
	NMDeviceWifi* _tmp67_;
	NMDeviceWifi* _tmp68_;
	NMDeviceWifi* _tmp69_;
	NMDeviceWifi* _tmp70_;
	GPtrArray* aps = NULL;
	NMDeviceWifi* _tmp71_;
	GPtrArray* _tmp72_;
	GPtrArray* _tmp73_;
	gboolean _tmp74_ = FALSE;
	GPtrArray* _tmp75_;
	GtkBox* content_box = NULL;
	GtkBox* _tmp80_;
	GtkBox* _tmp81_;
	GtkRevealer* _tmp82_;
	GtkBox* _tmp83_;
	GtkFrame* _tmp84_;
	GtkBox* _tmp85_;
	parent_class = G_OBJECT_CLASS (network_wifi_interface_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("network-wireless");
	_tmp1_ = _tmp0_;
	switchboard_settings_page_set_icon ((SwitchboardSettingsPage*) self, (GIcon*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = (GtkStack*) gtk_stack_new ();
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->placeholder);
	self->priv->placeholder = _tmp2_;
	_tmp3_ = (GtkListBox*) gtk_list_box_new ();
	gtk_list_box_set_activate_on_single_click (_tmp3_, FALSE);
	gtk_list_box_set_selection_mode (_tmp3_, GTK_SELECTION_SINGLE);
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, TRUE);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->wifi_list);
	self->priv->wifi_list = _tmp3_;
	_tmp4_ = self->priv->wifi_list;
	gtk_list_box_set_sort_func (_tmp4_, _network_wifi_interface_sort_func_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
	_tmp5_ = self->priv->wifi_list;
	_tmp6_ = self->priv->placeholder;
	gtk_list_box_set_placeholder (_tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->wifi_list;
	gtk_widget_add_css_class ((GtkWidget*) _tmp7_, GRANITE_STYLE_CLASS_RICH_LIST);
	_tmp8_ = g_strdup (_ ("Turn off the Hotspot Mode to connect to other Access Points."));
	_tmp9_ = granite_placeholder_new (_ ("This device is in Hotspot Mode"));
	granite_placeholder_set_description (_tmp9_, _tmp8_);
	_g_free0 (_tmp8_);
	g_object_ref_sink (_tmp9_);
	hotspot_mode_alert = _tmp9_;
	_tmp10_ = self->priv->wifi_list;
	_tmp11_ = _g_object_ref0 ((GtkWidget*) _tmp10_);
	_tmp12_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
	gtk_scrolled_window_set_child (_tmp12_, _tmp11_);
	_g_object_unref0 (_tmp11_);
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->scrolled);
	self->scrolled = _tmp12_;
	_tmp13_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->list_stack);
	self->list_stack = _tmp13_;
	_tmp14_ = self->list_stack;
	_tmp15_ = hotspot_mode_alert;
	gtk_stack_add_child (_tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = self->list_stack;
	_tmp17_ = self->scrolled;
	gtk_stack_add_child (_tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = self->list_stack;
	_tmp19_ = self->scrolled;
	gtk_stack_set_visible_child (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->list_stack;
	_tmp21_ = _g_object_ref0 ((GtkWidget*) _tmp20_);
	_tmp22_ = (GtkFrame*) gtk_frame_new (NULL);
	gtk_frame_set_child (_tmp22_, _tmp21_);
	_g_object_unref0 (_tmp21_);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp22_, TRUE);
	g_object_ref_sink (_tmp22_);
	main_frame = _tmp22_;
	_tmp23_ = main_frame;
	gtk_widget_add_css_class ((GtkWidget*) _tmp23_, GRANITE_STYLE_CLASS_VIEW);
	_tmp24_ = ((NetworkWidgetsPage*) self)->info_box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp24_, 12);
	_tmp25_ = ((NetworkWidgetsPage*) self)->info_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp25_, 12);
	_tmp26_ = ((NetworkWidgetsPage*) self)->info_box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp26_, 12);
	_tmp27_ = ((NetworkWidgetsPage*) self)->info_box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp27_, 12);
	_tmp28_ = ((NetworkWidgetsPage*) self)->info_box;
	_tmp29_ = _g_object_ref0 ((GtkWidget*) _tmp28_);
	_tmp30_ = (GtkPopover*) gtk_popover_new ();
	gtk_popover_set_child (_tmp30_, _tmp29_);
	_g_object_unref0 (_tmp29_);
	gtk_popover_set_position (_tmp30_, GTK_POS_BOTTOM);
	g_object_ref_sink (_tmp30_);
	_g_object_unref0 (self->popover);
	self->popover = _tmp30_;
	_tmp31_ = (GtkFrame*) gtk_frame_new (NULL);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp31_, 12);
	g_object_ref_sink (_tmp31_);
	_g_object_unref0 (self->connected_frame);
	self->connected_frame = _tmp31_;
	_tmp32_ = self->connected_frame;
	_tmp33_ = _g_object_ref0 ((GtkWidget*) _tmp32_);
	_tmp34_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_child (_tmp34_, _tmp33_);
	_g_object_unref0 (_tmp33_);
	gtk_revealer_set_transition_type (_tmp34_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (self->top_revealer);
	self->top_revealer = _tmp34_;
	_tmp35_ = switchboard_settings_page_add_button ((SwitchboardSettingsPage*) self, _ ("Edit Connections…"));
	settings_button = _tmp35_;
	_tmp36_ = settings_button;
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) _network_widgets_page_edit_connections_gtk_button_clicked, (NetworkWidgetsPage*) self, 0);
	_tmp37_ = switchboard_settings_page_add_button ((SwitchboardSettingsPage*) self, _ ("Connect to Hidden Network…"));
	_g_object_unref0 (self->hidden_btn);
	self->hidden_btn = _tmp37_;
	_tmp38_ = self->hidden_btn;
	g_signal_connect_object (_tmp38_, "clicked", (GCallback) _network_wifi_interface_connect_to_hidden_gtk_button_clicked, self, 0);
	_tmp39_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
	_tmp40_ = _tmp39_;
	_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, nm_device_wifi_get_type (), NMDeviceWifi));
	_g_object_unref0 (self->wifi_device);
	self->wifi_device = _tmp41_;
	network_wifi_interface_set_active_wifi_item (self, NULL);
	_tmp42_ = g_strdup (_ ("There are no wireless access points within range."));
	_tmp43_ = granite_placeholder_new (_ ("No Access Points Available"));
	granite_placeholder_set_description (_tmp43_, _tmp42_);
	_g_free0 (_tmp42_);
	g_object_ref_sink (_tmp43_);
	no_aps_alert = _tmp43_;
	_tmp44_ = g_strdup (_ ("Enable wireless to discover nearby wireless access points."));
	_tmp45_ = granite_placeholder_new (_ ("Wireless Is Disabled"));
	granite_placeholder_set_description (_tmp45_, _tmp44_);
	_g_free0 (_tmp44_);
	g_object_ref_sink (_tmp45_);
	wireless_off_alert = _tmp45_;
	_tmp46_ = (GtkSpinner*) gtk_spinner_new ();
	gtk_widget_set_visible ((GtkWidget*) _tmp46_, TRUE);
	gtk_widget_set_halign ((GtkWidget*) _tmp46_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp46_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp46_);
	spinner = _tmp46_;
	_tmp47_ = spinner;
	gtk_spinner_start (_tmp47_);
	_tmp48_ = (GtkLabel*) gtk_label_new (_ ("Scanning for Access Points…"));
	gtk_widget_set_visible ((GtkWidget*) _tmp48_, TRUE);
	gtk_label_set_wrap (_tmp48_, TRUE);
	gtk_label_set_wrap_mode (_tmp48_, PANGO_WRAP_WORD_CHAR);
	gtk_label_set_max_width_chars (_tmp48_, 30);
	gtk_label_set_justify (_tmp48_, GTK_JUSTIFY_CENTER);
	g_object_ref_sink (_tmp48_);
	scanning = _tmp48_;
	_tmp49_ = scanning;
	gtk_widget_add_css_class ((GtkWidget*) _tmp49_, GRANITE_STYLE_CLASS_H2_LABEL);
	_tmp50_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	gtk_widget_set_visible ((GtkWidget*) _tmp50_, TRUE);
	gtk_widget_set_valign ((GtkWidget*) _tmp50_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp50_);
	scanning_box = _tmp50_;
	_tmp51_ = scanning_box;
	_tmp52_ = scanning;
	gtk_box_append (_tmp51_, (GtkWidget*) _tmp52_);
	_tmp53_ = scanning_box;
	_tmp54_ = spinner;
	gtk_box_append (_tmp53_, (GtkWidget*) _tmp54_);
	_tmp55_ = self->priv->placeholder;
	_tmp56_ = no_aps_alert;
	gtk_stack_add_named (_tmp55_, (GtkWidget*) _tmp56_, "no-aps");
	_tmp57_ = self->priv->placeholder;
	_tmp58_ = wireless_off_alert;
	gtk_stack_add_named (_tmp57_, (GtkWidget*) _tmp58_, "wireless-off");
	_tmp59_ = self->priv->placeholder;
	_tmp60_ = scanning_box;
	gtk_stack_add_named (_tmp59_, (GtkWidget*) _tmp60_, "scanning");
	_tmp61_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp61_, "no-aps");
	_tmp62_ = rf_kill_manager_new ();
	_g_object_unref0 (self->priv->rfkill);
	self->priv->rfkill = _tmp62_;
	_tmp63_ = self->priv->rfkill;
	rf_kill_manager_open (_tmp63_);
	_tmp64_ = self->priv->rfkill;
	g_signal_connect_object (_tmp64_, "device-added", (GCallback) _network_widgets_page_update_rf_kill_manager_device_added, (NetworkWidgetsPage*) self, 0);
	_tmp65_ = self->priv->rfkill;
	g_signal_connect_object (_tmp65_, "device-changed", (GCallback) _network_widgets_page_update_rf_kill_manager_device_changed, (NetworkWidgetsPage*) self, 0);
	_tmp66_ = self->priv->rfkill;
	g_signal_connect_object (_tmp66_, "device-deleted", (GCallback) _network_widgets_page_update_rf_kill_manager_device_deleted, (NetworkWidgetsPage*) self, 0);
	_tmp67_ = self->wifi_device;
	g_signal_connect_object ((GObject*) _tmp67_, "notify::active-access-point", (GCallback) _network_widgets_page_update_g_object_notify, (NetworkWidgetsPage*) self, 0);
	_tmp68_ = self->wifi_device;
	g_signal_connect_object (_tmp68_, "access-point-added", (GCallback) _network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added, self, 0);
	_tmp69_ = self->wifi_device;
	g_signal_connect_object (_tmp69_, "access-point-removed", (GCallback) _network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed, self, 0);
	_tmp70_ = self->wifi_device;
	g_signal_connect_object ((NMDevice*) _tmp70_, "state-changed", (GCallback) _network_widgets_page_update_nm_device_state_changed, (NetworkWidgetsPage*) self, 0);
	_tmp71_ = self->wifi_device;
	_tmp72_ = nm_device_wifi_get_access_points (_tmp71_);
	_tmp73_ = _g_ptr_array_ref0 (_tmp72_);
	aps = _tmp73_;
	_tmp75_ = aps;
	if (_tmp75_ != NULL) {
		GPtrArray* _tmp76_;
		gint _tmp77_;
		gint _tmp78_;
		_tmp76_ = aps;
		_tmp77_ = vala_g_ptr_array_get_length (_tmp76_);
		_tmp78_ = _tmp77_;
		_tmp74_ = _tmp78_ > 0;
	} else {
		_tmp74_ = FALSE;
	}
	if (_tmp74_) {
		GPtrArray* _tmp79_;
		_tmp79_ = aps;
		g_ptr_array_foreach (_tmp79_, _network_wifi_interface_access_point_added_cb_gfunc, self);
	}
	_tmp80_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp80_);
	content_box = _tmp80_;
	_tmp81_ = content_box;
	_tmp82_ = self->top_revealer;
	gtk_box_append (_tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = content_box;
	_tmp84_ = main_frame;
	gtk_box_append (_tmp83_, (GtkWidget*) _tmp84_);
	_tmp85_ = content_box;
	switchboard_settings_page_set_child ((SwitchboardSettingsPage*) self, (GtkWidget*) _tmp85_);
	network_widgets_page_update ((NetworkWidgetsPage*) self);
	_g_object_unref0 (content_box);
	_g_ptr_array_unref0 (aps);
	_g_object_unref0 (scanning_box);
	_g_object_unref0 (scanning);
	_g_object_unref0 (spinner);
	_g_object_unref0 (wireless_off_alert);
	_g_object_unref0 (no_aps_alert);
	_g_object_unref0 (settings_button);
	_g_object_unref0 (main_frame);
	_g_object_unref0 (hotspot_mode_alert);
	return obj;
}

static void
network_wifi_interface_class_init (NetworkWifiInterfaceClass * klass,
                                   gpointer klass_data)
{
	network_wifi_interface_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWifiInterface_private_offset);
	((NetworkWidgetsPageClass *) klass)->update_name = (void (*) (NetworkWidgetsPage*, gint)) network_wifi_interface_real_update_name;
	((NetworkWidgetsPageClass *) klass)->update = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_update;
	((NetworkWidgetsPageClass *) klass)->update_status = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_update_status;
	((NetworkWidgetsPageClass *) klass)->update_switch = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_update_switch;
	((NetworkWidgetsPageClass *) klass)->control_switch_activated = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_control_switch_activated;
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_interface_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_interface_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_wifi_interface_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_wifi_interface_finalize;
}

static void
network_wifi_interface_instance_init (NetworkWifiInterface * self,
                                      gpointer klass)
{
	self->priv = network_wifi_interface_get_instance_private (self);
	self->priv->timeout_scan = (guint) 0;
	self->connected_box = NULL;
}

static void
network_wifi_interface_finalize (GObject * obj)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	_g_object_unref0 (self->priv->rfkill);
	_g_object_unref0 (self->wifi_device);
	_g_object_unref0 (self->priv->active_ap);
	_g_object_unref0 (self->priv->wifi_list);
	_g_object_unref0 (self->priv->_active_wifi_item);
	_g_object_unref0 (self->priv->placeholder);
	_g_object_unref0 (self->connected_frame);
	_g_object_unref0 (self->list_stack);
	_g_object_unref0 (self->scrolled);
	_g_object_unref0 (self->hotspot_mode_alert);
	_g_object_unref0 (self->connected_box);
	_g_object_unref0 (self->top_revealer);
	_g_object_unref0 (self->disconnect_btn);
	_g_object_unref0 (self->settings_btn);
	_g_object_unref0 (self->hidden_btn);
	_g_object_unref0 (self->info_btn);
	_g_object_unref0 (self->popover);
	G_OBJECT_CLASS (network_wifi_interface_parent_class)->finalize (obj);
}

static GType
network_wifi_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiInterface), 0, (GInstanceInitFunc) network_wifi_interface_instance_init, NULL };
	GType network_wifi_interface_type_id;
	network_wifi_interface_type_id = g_type_register_static (NETWORK_WIDGETS_TYPE_PAGE, "NetworkWifiInterface", &g_define_type_info, 0);
	NetworkWifiInterface_private_offset = g_type_add_instance_private (network_wifi_interface_type_id, sizeof (NetworkWifiInterfacePrivate));
	return network_wifi_interface_type_id;
}

GType
network_wifi_interface_get_type (void)
{
	static volatile gsize network_wifi_interface_type_id__once = 0;
	if (g_once_init_enter (&network_wifi_interface_type_id__once)) {
		GType network_wifi_interface_type_id;
		network_wifi_interface_type_id = network_wifi_interface_get_type_once ();
		g_once_init_leave (&network_wifi_interface_type_id__once, network_wifi_interface_type_id);
	}
	return network_wifi_interface_type_id__once;
}

static void
_vala_network_wifi_interface_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_wifi_interface_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

